local Enemy = Enemy
local g = {}
local fr = {}
local ic = Enemy.Intercom

function Enemy.ReadyCheckInitialize ()

  Enemy.readycheck = g
  fr = Enemy.unitFrames
  
  CreateWindow ("EnemyRCWindow", true)
  local dx, dy = WindowGetDimensions ("Root")
  -- 2134 x 1200
  ww = Enemy.toint(dx / 7)
  wh = Enemy.toint(dy / 1.5)
  WindowSetDimensions ("EnemyRCWindow", ww, wh)
  WindowSetTintColor("EnemyRCWindow", 255, 50, 50)
  LabelSetTextColor("EnemyRCLabel", 255, 255, 100)
  LabelSetText("EnemyRCLabel", L"READY!" )
  LayoutEditor.RegisterWindow ("EnemyRCWindow", L"ReadyCheck", L"ReadyCheck", false, false, true, nil)	
  
  WindowClearAnchors("EnemyRCWindow")
  WindowAddAnchor("EnemyRCWindow", "center", "Root", "center", 0, 0)

  Enemy.AddEventHandler ("ReadyCheck", "IntercomMessageReadyCheck", Enemy.RC_OnIntercomMessageRC)
  Enemy.AddEventHandler ("ReadyCheck", "IntercomMessageReportReady", Enemy.RC_OnIntercomMessageRD)
  
  Enemy.AddEventHandler ("EnemyRCWindow", "IconCreateContextMenu", function (data)
    table.insert (data,	{
			text = L"ReadyCheck",
			callback = Enemy.ReadyCheck_DoCheck
		})
  end)
  WindowSetShowing ("EnemyRCWindow", false)
	Enemy.TriggerEvent ("ReadyCheckInitialized")
end

function Enemy.toint(n)
    local s = tostring(n)
    local i, j = s:find('%.')
    if i then
        return tonumber(s:sub(1, i-1))
    else
        return n
    end
end

function Enemy.EnemyRCButtonClick ()
  Enemy.ReportReady()
end

function Enemy.ReportReady ()
  WindowSetShowing ("EnemyRCWindow", false)
  local message = "EnemyAddon:ReportReady"
  Enemy.IntercomSendMessage ("readycheck", message)
end

function Enemy.RC_OnIntercomMessageRD (from)
  local sender = from
  local windowName = Enemy.getUnitFrameIndex(from, 0)
  WindowSetAlpha (windowName, 1)
end

function Enemy.getUnitFrameIndex (name, param)
  -- 0 - window name
  -- 1 - windown itself
  local frame = fr.frames
  for _, g in pairs (frame) do
    for _, p in pairs (g) do
      if (p.playerName == name) then
        if param == 0 then return p.windowName end
        if param == 1 then return p end
      end
    end
  end
end


function Enemy.ReadyCheck_DoCheck ()
  if (Enemy.CanSendIntercomMessage ()) then
    local channel = Enemy.getIntercomChannelName()
    local thisChannel = Enemy.getThisChannel()
    local message = "EnemyAddon:ReadyCheck"
    Enemy.IntercomSendMessage ("readycheck", message)
  else 
    Enemy.Print ("You need to join channel first")
  end
end

function Enemy.showCheckInWindow ()
  WindowSetShowing ("EnemyRCWindow", true)
end

function Enemy.RC_OnIntercomMessageRC (from)
  local sender = tostring(from)
  local name = tostring(GameData.Player.name)
  name = string.sub (name, 1, string.len(name)-2)
  local frame = fr.frames
  local tabIndex = 8
  if (Enemy.groups.groupType == Enemy.GroupTypes.Warband) then
    tabIndex = 7
  end
   
  local leaderName = ""
  for _, g in pairs (frame) do
    for _, p in pairs (g) do
      if (p.playerName == nil) then
      else 
        if (p.parts[tabIndex]._t.cache.isGroupLeader) then
          leaderName = p.playerName
        end
        WindowSetAlpha (p.windowName, 0.2)
      end
    end
  end
  if sender == name then
    Enemy.ReportReady()
  else 
    Enemy.showCheckInWindow ()
    if (sender == tostring(leaderName)) then
      SendChatText (L"/follow "..leaderName)
    end
  end
end
